Crowd_Funding_System/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('accounts/', include('apps.accounts.urls')),
    path('admin/', include('apps.admin_dashboard.urls')),
    path('projects/', include('apps.projects.urls')),
    path('categories/', include('apps.categories.urls')),
    path('', include('apps.homepage.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apps/admin_dashboard/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('index/', views.index, name='admin_dashboard'),
    path('users/', views.show_users, name='show_users'),
    path('users/<int:id>/delete/', views.delete_user, name='delete_user'),
    path('projects/', views.show_projects, name='show_projects'),
    path('projects/<slug:slug>/', views.show_project, name='show_project'),
    path('projects/<slug:slug>/update/', views.edit_project, name='edit_project'),
    path('projects/<slug:slug>/featured/', views.featured_project, name='featured_project'),
    path('projects/<slug:slug>/delete/', views.delete_project, name='delete_project'),
    path('projects/<slug:slug>/comments/<int:id>/delete/', views.delete_comment, name='delete_comment'),
    path('projects/<slug:slug>/project_pictures/', views.project_picture, name='project_picture'),
    path('projects/<slug:slug>/delete_picture/<int:pk>/', views.delete_project_picture, name='delete_project_picture'),
    path('categories/', views.show_categories, name='show_categories'),
    path('categories/create/', views.create_category, name='create_category'),
    path('categories/<slug:slug>/', views.show_category, name='show_category'),
    path('categories/<slug:slug>/update/', views.update_category, name='update_category'),
    path('categories/<slug:slug>/delete/', views.delete_category, name='delete_category'),
    path('donations/', views.show_donations, name='show_donations'),
    path('reports/', views.show_reports, name='show_reports'),
    path('projects_reports/<int:id>/', views.show_project_report, name='show_project_report'),
    path('projects_reports/<int:id>/delete/', views.delete_project_report, name='delete_project_report'),
    path('comments_reports/<int:id>/', views.show_comment_report, name='show_comment_report'),
    path('comments_reports/<int:id>/delete/', views.delete_comment_report, name='delete_comment_report'),
]

apps/projects/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.projects_list, name='projects_list'),
    path('create/', views.create_project, name='create_project'),
    path('<slug:slug>/', views.project_details, name='project_details'),
    path('<slug:slug>/rate', views.rate_project, name='rate_project'),
    path('<slug:slug>/donate/', views.add_donation, name='add_donation'),
    path('<slug:slug>/cancel/', views.cancel_project, name='cancel_project'),
    path('<slug:slug>/rate/', views.rate_project, name='rate_project'),
    path('<slug:slug>/donate/', views.add_donation, name='add_donation'),
    path('<slug:slug>/comment/', views.add_comment, name='add_comment'),
    path('<slug:slug>/report/', views.report_project, name='report_project'),
    path('comments/<int:comment_id>/report/', views.report_comment, name='report_comment'),
    # path('comments/<int:comment_id>/reply/', views.add_reply, name='add_reply'),
    path('tags/<slug:slug>/', views.tagged, name="tagged"),
]

apps/admin_dashboard/models.py
from django.db import models

# Create your models here.

apps/projects/models.py
import os

from django.utils import timezone
from django.utils.text import slugify
from django.db import models
from django.urls import reverse
from django.shortcuts import get_object_or_404
from django.core.validators import MaxValueValidator, MinValueValidator
from taggit.managers import TaggableManager

from apps.accounts.models import CustomUser
from apps.categories.models import Category


# ===================== Project Model =====================
class Project(models.Model):
    STATUS_CHOICES = [
        ('active', 'Active'),
        ('completed', 'Completed'),
    ]

    title = models.CharField(max_length=100, unique=True)
    slug = models.SlugField(max_length=100, unique=True, editable=False, blank=True)
    details = models.TextField()
    total_target = models.IntegerField()
    current_fund = models.IntegerField(default=0)
    creator = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    category = models.ForeignKey(Category, on_delete=models.SET_DEFAULT, default=None, related_name='projects')
    start_time = models.DateTimeField(auto_now_add=True)
    end_time = models.DateTimeField()
    tags = TaggableManager()
    updated_at = models.DateTimeField(auto_now=True)
    rate = models.FloatField(default=0, null=True, validators=[MinValueValidator(0.5), MaxValueValidator(5.0)])
    status = models.CharField(max_length=20, choices=STATUS_CHOICES, default='active')
    featured = models.BooleanField(default=False)
    featured_at = models.DateTimeField(default=None, null=True)

    def __str__(self):
        return f"{self.title}"

    def save(self, *args, **kwargs):
        self.slug = slugify(self.title)

        # Check if current_fund has reached total_target and update status to 'completed'
        if self.current_fund >= self.total_target and self.status != 'completed':
            self.status = 'completed'

        # Check if featured field has changed and update featured_at
        if self.featured and not self.featured_at:
            self.featured_at = timezone.now()
        elif not self.featured:
            self.featured_at = None

        super(Project, self).save(*args, **kwargs)

    @classmethod
    def get_project_by_slug(cls, slug):
        return get_object_or_404(cls, slug=slug)

    @property
    def show_url(self):
        return reverse('project_details', args=[self.slug])

    @property
    def update_url(self):
        return reverse('update_project', args=[self.slug])

    @property
    def cancel_url(self):
        return reverse('cancel_project', args=[self.slug])

    @property
    def pictures_urls(self):
        return [pic.image.url for pic in self.pictures.all()]

    @property
    def picture_url(self):
        first_picture = self.pictures.first()
        if first_picture:
            return first_picture.image.url

    @property
    def get_tags(self):
        return self.tags.all()

    @property
    def percentag(self):
        if self.total_target == 0:
            return 0
        value = (self.current_fund * 100) / self.total_target
        return round(value, 2)


# ===================== ProjectPicture Model =====================
def project_picture_upload_path(instance, filename):
    if instance.project.pictures.exists():
        project_directory_name = os.path.dirname(instance.project.pictures.first().image.path)
    else:
        project_directory_name = instance.project.title.replace(' ', '_')
    return os.path.join('project_uploads', project_directory_name, filename)


class ProjectPicture(models.Model):
    project = models.ForeignKey(Project, on_delete=models.CASCADE, related_name="pictures")
    image = models.ImageField(db_column='image', upload_to=project_picture_upload_path)

    @property
    def image_url(self):
        return f"/media/{self.image}"


# ===================== Donation Model =====================
class Donation(models.Model):
    amount = models.IntegerField()
    project = models.ForeignKey(Project, on_delete=models.CASCADE, related_name='donations')
    user = models.ForeignKey(CustomUser, on_delete=models.SET_DEFAULT, default=None, null=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.amount


# ===================== Comment Model =====================
class Comment(models.Model):
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    project = models.ForeignKey(Project, on_delete=models.CASCADE, related_name='comments')
    text = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)


# ===================== Reply Model =====================
class Reply(models.Model):
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE, related_name='replies')
    text = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)


class CommentReport(models.Model):
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE)
    reason = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)


# ===================== Report Project Model =====================
class ProjectReport(models.Model):
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    project = models.ForeignKey(Project, on_delete=models.CASCADE)
    reason = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)


# ===================== Rating Model =====================
class Rating(models.Model):
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    project = models.ForeignKey(Project, on_delete=models.CASCADE,related_name='ratings')
    value = models.FloatField(validators=[MinValueValidator(0.5), MaxValueValidator(5.0)])  
    created_at = models.DateTimeField(auto_now_add=True)
    
    class Meta:
        unique_together = ('user', 'project')

apps/admin_dashboard/forms.py
from django import forms
from apps.categories.models import Category


class CategoryForm(forms.ModelForm):
    class Meta:
        model = Category
        fields = '__all__'

    name = forms.CharField(
        widget=forms.TextInput(attrs={"placeholder": "Name", "class": "form-control"})
    )

    description = forms.CharField(
        widget=forms.Textarea(attrs={"placeholder": "Description", "class": "form-control", "rows": 3}),
    )

apps/projects/forms.py
from django.utils import timezone
from django import forms
from taggit import forms as taggit_forms

from .models import Project, Donation, Comment, ProjectReport, CommentReport


class ProjectForm(forms.ModelForm):
    title = forms.CharField(
        widget=forms.TextInput(attrs={"placeholder": "Title", "class": "form-control"})
    )

    details = forms.CharField(
        widget=forms.Textarea(attrs={"placeholder": "Details", "class": "form-control", "rows": 5}),
    )

    total_target = forms.IntegerField(
        widget=forms.NumberInput(attrs={"placeholder": "Total Target", "class": "form-control", "min": "0"}),
    )

    start_time = forms.DateField(
        widget=forms.DateInput(attrs={"placeholder": "Start Date", "type": "date", "class": "form-control", "readonly": True}),
        required=False,
        initial=timezone.now(),
    )

    end_time = forms.DateField(
        widget=forms.DateInput(attrs={"placeholder": "End Date", "type": "date", "class": "form-control"})
    )

    tags = taggit_forms.TagField(
        widget=forms.TextInput(attrs={"placeholder": "Tags", "class": "form-control"}),
        required=False
    )

    class Meta:
        model = Project
        fields = ('title', 'details', 'end_time', 'total_target', 'category', 'tags')

    def clean_title(self):
        title = self.cleaned_data['title']
        if len(title) < 3:
            raise forms.ValidationError("Title must be at least 3 characters long.")
        elif Project.objects.filter(title=title).exists() and self.instance.title != title:
            raise forms.ValidationError("A project with this title already exists.")
        return title

    def clean_total_target(self):
        total_target = self.cleaned_data.get('total_target')
        if total_target is not None and total_target <= 0:
            raise forms.ValidationError("Total Target must be a positive number.")
        return total_target

    def clean(self):
        cleaned_data = super().clean()
        start_time = cleaned_data.get("start_time")
        end_time = cleaned_data.get("end_time")

        if start_time and end_time and end_time <= start_time:
            self.add_error("end_time", "End time should be greater than Start time.")


class DonationForm(forms.ModelForm):
    class Meta:
        model = Donation
        fields = ['amount']
        labels = {
            'amount': 'Donation Amount (EGP)'
        }
        widgets = {
            'amount': forms.NumberInput(attrs={'class': 'form-control', 'placeholder': 'Enter donation amount'})
        }

    def clean_amount(self):
        amount = self.cleaned_data['amount']
        if amount <= 0:
            raise forms.ValidationError("Donation amount should be greater than zero.")
        return amount


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['text']
        labels = {
            'text': 'Add a comment'
        }
        widgets = {
            'text': forms.Textarea(attrs={'class': 'form-control', 'rows': 3, 'placeholder': 'Write your comment here'})
        }


class ReportProjectForm(forms.ModelForm):
    class Meta:
        model = ProjectReport
        fields = ['reason']
        labels = {
            'reason': 'Reason for Report'
        }
        widgets = {
            'reason': forms.Textarea(attrs={'class': 'form-control', 'rows': 3, 'placeholder': 'Please provide details about why you are reporting this project.'})
        }


class ReportCommentForm(forms.ModelForm):
    class Meta:
        model = CommentReport
        fields = ['reason']
        labels = {
            'reason': 'Reason for Report'
        }
        widgets = {
            'reason': forms.Textarea(attrs={'class': 'form-control', 'rows': 3, 'placeholder': 'Please provide details about why you are reporting this comment.'})
        }


class ReplyCommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['text']
        labels = {
            'text': 'Reply to comment'
        }
        widgets = {
            'text': forms.Textarea(attrs={'class': 'form-control', 'rows': 3, 'placeholder': 'Write your reply here'})
        }

apps/admin_dashboard/templates/admin_dashboard/projects/edit_project.html
{% extends 'admin_dashboard/base.html' %}

{% block content %}
<section>
        <div class="container">
            <div class="row">
                <div class="col-12 col-md-8 col-lg-8 mx-md-auto">
                    <form action="." class="p-3 rounded" enctype="multipart/form-data" method="POST">
                        {% csrf_token %}
                        <h1 class="my-3">Update Project</h1>

                        <!-- Start title -->
                        <div class="mb-3">
                            <label class="form-label" for="id_title">Title</label>
                            <div class="input-group has-validation">
                                {{ form.title }}
                            </div>
                            {% for error in form.title.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End title -->

                        <!-- Start details -->
                        <div class="mb-4">
                            <label class="form-label" for="id_details">Details</label>
                            <div class="input-group has-validation">
                                {{ form.details }}
                            </div>
                            {% for error in form.details.errors %}
                            <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End details -->

                        <div class="row">
                            <!-- Start start_time -->
                            <div class="mb-4 col-md-6">
                                <label class="form-label" for="id_start_time">Start Time</label>
                                <div class="input-group has-validation">
                                    {{ form.start_time }}
                                </div>
                                {% for error in form.start_time.errors %}
                                <div class="invalid-feedback d-block">{{ error }}</div>
                                {% endfor %}
                            </div>
                            <!-- End start_time -->

                            <!-- start end_time -->
                            <div class="mb-4 col-md-6">
                                <label class="form-label" for="id_end_time">End Time</label>
                                <div class="input-group has-validation">
                                    {{ form.end_time }}
                                </div>
                                {% for error in form.end_time.errors %}
                                <div class="invalid-feedback d-block">{{ error }}</div>
                                {% endfor %}
                            </div>
                            <!-- End end_time -->
                        </div>

                        <div class="row">
                            <!-- Start total_target -->
                            <div class="mb-4 col-md-6">
                                <label class="form-label" for="id_total_target">Total Target</label>
                                <div class="input-group has-validation">
                                    {{ form.total_target }}
                                </div>
                                {% for error in form.total_target.errors %}
                                <div class="invalid-feedback d-block">{{ error }}</div>
                                {% endfor %}
                            </div>
                            <!-- End total_target -->

                            <!-- Start category -->
<div class="mb-4 col-md-6">
    <label class="form-label" for="id_category">Category</label>
    <div class="input-group has-validation">
        <select class="form-select" id="id_category" name="category">
            <option disabled value="">Select category</option>
            {% for op_value, op_label in form.fields.category.choices %}
                <option value="{{ op_value }}" {% if op_value == project.category.pk %}selected{% endif %}>
                    {{ op_label }}
                </option>
            {% endfor %}
        </select>
    </div>
    {% for error in form.category.errors %}
        <div class="invalid-feedback d-block">{{ error }}</div>
    {% endfor %}
</div>
<!-- End category -->

                        </div>
                        <!-- Start display pictures -->
                        <div class="form-group mb-4">
                            <div class="row">
                                {% for picture in project.pictures.all %}
                                <div class="col-md-3 mb-3">
                                    <div class="position-relative">
                                        <img src="{{ picture.image.url }}" alt="Project Image" class="img-thumbnail" style="max-width: 200px; height: 200px;">
                                    </div>
                                </div>
                                {% endfor %}
                            </div>
                            <a href="{% url 'project_picture' slug=project.slug%}" class="btn btn-info text-capitalize fs-5 text-bg-light">view picture</a>
                        </div>
                        <!-- End display pictures -->
                        <!-- Start pictures -->
                        <div class="form-group mb-4">
                            <label class="form-label" for="id_pictures">Add Pictures</label>
                            <input accept="image/jpeg, image/png, image/jpg" class="form-control" id="id_pictures" multiple name="image" type="file">
                            {% if messages %}
                                {% for message in messages %}
                                <p class="text-danger mt-1">{{ message }}</p>
                                {% endfor %}
                            {% endif %}
                        </div>
                        <!-- End pictures -->
                        
                        <!-- Start tags -->
                        <div class="form-group mb-4">
                            <div class="form-group mb-4">
                                <label class="form-label" for="id_tags">Tags</label>
                                <input class="form-control "data-role="tagsinput" id="id_tags" name="tags" type="text" value="{{ project.tags.names|join:' ' }}">
                            </div>

                            {% for error in form.tags.errors %}
                                <div class="invalid-feedback d-block">{{ error }}</div>
                            {% endfor %}
                        </div>
                        <!-- End tags -->

                        <div class="text-center my-3">
                            <button class="btn btn-warning " type="submit">Update</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
</section>
{% endblock %}

apps/admin_dashboard/templates/admin_dashboard/projects/project_list.html
{% extends 'admin_dashboard/base.html' %}
{% block content %}
<main>
    <div class="container-fluid px-4">
        <div class="card my-4">
            <div class="card-header bg-danger text-white fs-5">
                <i class="fas fa-table me-1"></i>
                All Created Projects
            </div>
            <div class="card-body">
                <form>
                    {% csrf_token %}
                    <!-- Other form fields -->
                </form>
                <table class="table table-bordered text-center text-capitalize " id="datatablesSimple">
                    <!-- Table headers -->
                    <thead>
                    <tr>
                        <th>Title</th>
                        <th>preview</th>
                        <th>edit</th>
                        <th>delete</th>
                        <th>status</th>
                        <th>Is Featured</th>
                    </tr>
                    </thead>
                    <tbody>
                    <!-- Table rows -->
                    {% for project in projects %}
                    <tr>
                        <td>{{ project.title }}</td>
                        <td><a class="btn btn-primary text-white " href="{% url 'show_project' slug=project.slug %}">
                            <i class="fa-regular fa-eye"></i></a></td>
                        <td><a class="btn btn-warning mx-3 text-white" href="{% url 'edit_project' slug=project.slug %}">
                            <i class="fa-solid fa-pen-to-square"></i></a>
                        </td>
                        <td>
                            <form action="{% url 'delete_project' slug=project.slug %}" method="post">
                                {% csrf_token %}
                                <button class="btn btn-danger me-3" data-bs-target="#confirmDeleteModal{{ project.id }}" data-bs-toggle="modal"
                                        type="button">
                                    <i class="fa-solid fa-trash-can"></i>
                                </button>
                                <!-- Modal -->
                                <div aria-hidden="true" aria-labelledby="confirmDeleteModalLabel{{ project.id }}" class="modal fade"
                                     id="confirmDeleteModal{{ project.id }}" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="confirmDeleteModalLabel{{ project.id }}">Confirm Delete</h5>
                                                <button aria-label="Close" class="btn-close" data-bs-dismiss="modal" type="button"></button>
                                            </div>
                                            <div class="modal-body">
                                                Are you sure you want to delete this project?
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" data-bs-dismiss="modal" type="button">Cancel</button>
                                                <button class="btn btn-danger" type="submit">Yes, Delete</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </td>

                        <td class="fs-5">{{ project.status }}</td>
                        <td>
                            <button class="toggle-feature btn
                                                {% if project.featured %}
                                                     btn-warning
                                                {% else %}
                                                    btn-secondary
                                                {% endif %}"
                                    data-is-featured="{{ project.featured }}"
                                    data-project-id="{{ project.id }}"
                                    data-project-slug="{{ project.slug }}">
                                {% if project.featured %}
                                Featured
                                {% else %}
                                Not Featured
                                {% endif %}
                            </button>
                        </td>
                    </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    {% if messages %}
    {% for message in messages %}
    <div class="my-4 mx-auto alert alert-danger col-md-4 text-center fs-5" id="success-message" role="alert">
        {{ message }}
    </div>
    {% endfor %}
    {% endif %}

</main>

<script>
    document.addEventListener('DOMContentLoaded', function () {
        const toggleButtons = document.querySelectorAll('.toggle-feature');

        toggleButtons.forEach(button => {
            button.addEventListener('click', function () {
                const projectSlug = this.getAttribute('data-project-slug'); // Accessing the data-project-slug attribute
                console.log(projectSlug);

                const csrfToken = document.querySelector('[name=csrfmiddlewaretoken]').value;
                console.log(csrfToken);

                // Send a POST request to toggle the featured status
                fetch(`/admin/projects/${projectSlug}/featured/`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                        'X-CSRFToken': csrfToken
                    },
                    body: JSON.stringify({}), // No need to send additional data
                })
                    .then(response => {
                        if (response.ok) {
                            return response.json();
                        } else {
                            throw new Error('Failed to toggle featured status');
                        }
                    })
                    .then(data => {
                        // Update the button text
                        button.textContent = data.is_featured ? ' Featured' : 'not Featured';
                        console.log(button.textContent)
                        button.classList.toggle('btn-warning', data.is_featured);
                        button.classList.toggle('btn-secondary', !data.is_featured);
                    })
                    .catch(error => {
                        console.error('Error:', error.message);
                    });
            });
        });
        // Automatically hide the success message after 2 seconds
        setTimeout(function () {
            const successMessage = document.getElementById('success-message');
            if (successMessage) {
                successMessage.style.display = 'none';
            }
        }, 2000);
    });

</script>

{% endblock %}

apps/admin_dashboard/templates/admin_dashboard/projects/project_pictures.html
{% extends 'admin_dashboard/base.html' %}
{% block content %}
<h2 class="text-center my-3 bg-light ">Project Pictures</h2>

<div class="container ">
<a href="{% url 'edit_project' slug=project.slug %}" class="btn btn-info mb-3 fs-5 text-bg-light " >Back to Form</a>
<div class="row">
    {% for picture in pictures %}
    <div class="col-md-3 mb-3">
        <div class="card">
            <img src="{{ picture.image.url }}" class="card-img-top img-thumbnail rounded-0 " alt="Project Image" style="height: 250px; ">
            <div class="card-footer">
                <form action="{% url 'delete_project_picture' slug=project.slug pk=picture.pk %}" method="post" >
                    {% csrf_token %}
                    <button type="submit" class="btn btn-danger btn-block w-100">Delete</button>
                </form>
            </div>
        </div>
    </div>
    {% endfor %}
</div>
</div>
{% endblock %}